#include "defaultappui.h"

DefaultAppUi::DefaultAppUi(QWidget *parent) : QWidget(parent)
{
    setAttribute(Qt::WA_DeleteOnClose);
    initUi();
}

void DefaultAppUi::initUi()
{
    QVBoxLayout *vLyt = new QVBoxLayout(this);
    vLyt->setSpacing(8);
    vLyt->setContentsMargins(0, 0, 0, 0);

    TitleLabel *mTitleLabel = new TitleLabel(this);
    //~ contents_path /Defaultapp/Select Default Application
    mTitleLabel->setText(tr("DefaultAppWindow", "Select Default Application"));
    SettingGroup *mDefaultFrame = new SettingGroup(this);

    //~ contents_path /Defaultapp/Browser
    mBrowserFrame = new ComboxWidget(tr("Browser"));
    //~ contents_path /Defaultapp/Mail
    mMailFrame = new ComboxWidget(tr("Mail"));
    //~ contents_path /Defaultapp/Image Viewer
    mImageFrame = new ComboxWidget(tr("Image Viewer"));
    //~ contents_path /Defaultapp/Audio Player
    mAudioFrame = new ComboxWidget(tr("Audio Player"));
    //~ contents_path /Defaultapp/Video Player
    mVideoFrame = new ComboxWidget(tr("Video Player"));
    //~ contents_path /Defaultapp/Text Editor
    mTextFrame = new ComboxWidget(tr("Text Editor"));

    // 恢复默认
    mResetFrame = new PushButtonWidget(tr("Reset default apps to system recommended apps"));
    QPushButton* resetButton = mResetFrame->pushButton();
    if (nullptr != resetButton) {
        QFontMetrics fontMetrics(resetButton->font());
        QString hostnameText = tr("Reset");
        int fontSize = fontMetrics.width(hostnameText);
        if (fontSize > resetButton->width()) {
            QString hostnameNew = fontMetrics.elidedText(hostnameText, Qt::ElideRight, resetButton->width() - 15);
            resetButton->setText(hostnameNew);
            resetButton->setToolTip(hostnameText);
        } else {
            resetButton->setText(hostnameText);
            resetButton->setToolTip("");
        }
    }

    mDefaultFrame->addWidget(mBrowserFrame);
    mDefaultFrame->addWidget(mMailFrame);
    mDefaultFrame->addWidget(mImageFrame);
    mDefaultFrame->addWidget(mAudioFrame);
    mDefaultFrame->addWidget(mVideoFrame);
    mDefaultFrame->addWidget(mTextFrame);
    mDefaultFrame->addWidget(mResetFrame);

    vLyt->addWidget(mTitleLabel);
    vLyt->addWidget(mDefaultFrame);
    vLyt->addStretch();
}
